#!/usr/bin/perl -w
# $Id: eat-spam.pl,v 1.16 2004/02/25 19:53:06 cfry Exp $
# eat-spam: send a ton of email messages to the spammonger

use strict;

my $verbose = 1;
my $message_count = 10; # number of messages to process; 0 for all

# directories
my $base = '/afs/ece/usr/cfry/classes/middleware';
my $publiccorpus = "$base/publiccorpus";
my $assassin = "$base/spamassassin/usr/bin";
my $javacmd = "java -Djava.util.logging.config.file=$base/config/logging.properties";

my $send_easy_ham = 1;
my $send_hard_ham = 1;
my $send_spam = 1;
my $mix = 1;           # 1=mix all three categories; 0=send one cat at a time

# Create Client
my $clientid = 100;
my $rslt = `$javacmd com.spamnbeans.client.MPManager client exists $clientid`;
my $exit = ($? >> 8);
if ($exit != 0) {
	# TODO ultimately handle each type of exit code
	my $msg;
	if ($exit == 1) {
		$msg = 'MPManager class not found';
	}
	else {
		$msg = "unrecognized exit code: $exit";
	}
	die "MPManager error: $msg\n";
}
# TODO get rid of this (use exit code instead)
#if ($rslt !~ m/^TRUE/) {
#	die "ERROR - $rslt\n";
#}

# to whom do we deal (choose only one please)
#my $monger = "$assassin/spamassassin"; # the one and only true spamassassin
#my $monger = "$assassin/spamc -p 5342";        # and his client
my $monger = "$javacmd com.spamnbeans.client.MPClient $clientid";   # eat 'em while they're hot
#my $monger = "$base/bin/mail";         # hand off to the MTA

my (@easy_ham, @hard_ham, @spam);
if ($send_easy_ham) {
	open IN, "$publiccorpus/easy_ham.list";
	chomp (@easy_ham = <IN>);
}
if ($send_hard_ham) {
	open IN, "$publiccorpus/hard_ham.list";
	chomp (@hard_ham = <IN>);
}
if ($send_spam) {
	open IN, "$publiccorpus/spam.list";
	chomp (@spam = <IN>);
}
my @messages = (@easy_ham, @hard_ham, @spam);
if ($mix) {
	# Fisher-Yates Shuffle
	# http://www.perlmonks.org/index.pl?node=Fisher-Yates+shuffle
	my $i = @messages;
	while ($i--){
		my $j = int rand(1 + $i);
		next if $i == $j;
		@messages[$i, $j] = @messages[$j, $i];
	}
}
if ($message_count) {
	splice @messages, $message_count;
}
else {
	$message_count = @messages;
}

my $start_time = time;
foreach my $message (@messages) {
	if ($verbose) {
		if ($message =~ m/^easy_ham/) {
			print "_";
		}
		elsif ($message =~ m/^hard_ham/) {
			print "-";
		}
		elsif ($message =~ m/^spam/) {
			print "+";
		}
	}
	my @result = `$monger < $publiccorpus/$message`;
	my $exit = ($? >> 8);
	if ($exit != 0) {
		# TODO ultimately handle each type of exit code
		my $msg;
		if ($monger =~ m/^$javacmd/) {
			if ($exit == 1) {
				$msg = 'MPClient class not found';
			}
			elsif ($exit == 1100) {
				$msg = 'MPClient could not connect to server';
			}
			elsif ($exit == 2100) {
				$msg = 'MPClient could not read input message';
			}
			elsif ($exit == 2200) {
				$msg = 'Input message cannot be of length 0';
			}
			elsif ($exit == 2300) {
				$msg = "Invalid Client ID: $clientid";
			}
			elsif ($exit == 2400) {
				$msg = "No servers found";
			}
			elsif ($exit == 100) {
				$msg = 'MPClient encountered an unexpected error';
			}
			else {
				$msg = "unrecognized exit code: $exit";
			}
		}
		die "Spam processing error: $msg\n";
	}
	if (@result) {
		if ($verbose) {
			my $spam_level;
			foreach (@result) {
				if (m/^X-Spam-Level: ?(\**)$/) {
					$spam_level = length $1;
					last;
				}
			}
			if (defined $spam_level) {
				print "$spam_level\n";
			}
			else {
				die "There must be some problem; no new spam headers were found: @result\n";
			}
		}
	}
	else {
		die "There must be some problem; no output was returned.\n";
	}
}
if ($verbose) {
	print "\n";
}
my $end_time = time;
my $elapsed_time = $end_time - $start_time;
my $average_time = $elapsed_time / $message_count;
my $message_rate = $message_count / $elapsed_time;

print "elapsed seconds:    $elapsed_time\n";
print "messages processed: $message_count\n";
printf "   seconds/message: %.1f\n", $average_time;
printf "   messages/second: %.2f\n", $message_rate;
print "bytes processed:    ";

my $total_bytes;
foreach my $message (@messages) {
	# my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size, $atime,$mtime,$ctime,$blksize,$blocks) = stat("$publiccorpus/$message");
	my (undef,undef,undef,undef,undef,undef,undef,$size) = stat("$publiccorpus/$message");
	$total_bytes += $size;
}
print "$total_bytes\n";
my $average_bytes = $total_bytes / $message_count;
my $byte_rate = $average_bytes / $elapsed_time;

printf "   bytes/message:   %.0f\n", $average_bytes;
printf "   bytes/second:    %.0f\n", $byte_rate;
