// $Id: MsgHomeLocal.java,v 1.5 2004/02/28 15:36:29 gca Exp $
package com.spamnbeans.msg;

import java.util.Collection;

/**
 * The local home interface for a message.
 * <p>This interface is implemented by the container to create
 *   a local home object, which serves as a factory for
 *   EJB local home objects.
 * 
 * <p>One create() method exists in this Home Interface, which
 *   corresponds to the ejbCreate() method in the bean class.
 * 
 * @author Gary Ackley, <a href="mailto:gca@andrew.cmu.edu">gca@andrew.cmu.edu
 *         </a>
 * @version $Revision: 1.5 $
 */
public interface MsgHomeLocal extends javax.ejb.EJBLocalHome
{
	/*
	 * Creates a message:
	 * @param clientID := the client that submitted the message
	 * @param serverID := the server which processed the message
	 * @param timeStamp := when the client submitted the message
	 * @param msgSize := the size (in bytes) of the message
	 * 
	 * @return The newly created EJB local object.
	 */
	public MsgLocal createMsg(
			Integer messageID, Integer clientID, Integer serverID,
			String timeStamp, Integer msgSize, Integer msgState)
		throws javax.ejb.CreateException;
	
	
	// Finder methods.
	// - These are implemented by the container.
	// - You may customize the functionality of these methods the 
	//	 deployment descriptor through EJB-SQL and container tools.
	
	public MsgLocal findByPrimaryKey(Integer msgID)
	throws javax.ejb.FinderException;
	
	public Collection findByClientID(Integer clientID)
	throws javax.ejb.FinderException;
	
	public Collection findByServerID(Integer serverID)
	throws javax.ejb.FinderException;
		
	public Collection findByTimeStamp(String timeStamp)
	throws javax.ejb.FinderException;
		
	public Collection findByMsgSize(Integer msgSize)
	throws javax.ejb.FinderException;
		
	public Collection findAllMsgs()
	throws javax.ejb.FinderException;	
	
}
