// $Id: ClientStatBean.java,v 1.3 2004/03/01 04:32:54 gca Exp $

package com.spamnbeans.server;

import javax.ejb.EntityContext;
import javax.ejb.CreateException;

/**
 * Define the ClientStatBean methods.
 * 
 * <p>The ClientStat Bean tracks the statistics for a Client, identified by
 * its Name and ClientID.
 *
 * @author Andrew Boyer,
 *         <a href="mailto:aboyer@andrew.cmu.edu">aboyer@andrew.cmu.edu</a>
 * @version 1.0
 */
public abstract class ClientStatBean implements javax.ejb.EntityBean 
{
    /**
     * Create a new ClientStat EntityBean
     * @param clientID The ClientID (primary key) of the created Bean
     */
    public Integer ejbCreate(Integer clientID) throws CreateException
    {
	this.setClientID(clientID);
	return null;
    }
 
    /**
     * Not implemented
     */
    public void ejbPostCreate(Integer clientID) { }
   
    /**
     * JBoss generated field access function
     */
    public abstract void setClientID(Integer clientID);

    /**
     * JBoss generated field access function
     */
    public abstract Integer getClientID();
    
    /**
     * JBoss generated field access function
     */
    public abstract void setName(String name);

    /**
     * JBoss generated field access function
     */
    public abstract String getName();

    /**
     * JBoss generated field access function
     */
    public abstract void setEnable(boolean enable);

    /**
     * JBoss generated field access function
     */
    public abstract boolean getEnable();
    
    /**
     * Not implemented
     */
    public void setEntityContext(EntityContext ctx) { }


    /**
     * Not implemented
     */
    public void unsetEntityContext() { }


    /**
     * Not implemented
     */
    public void ejbActivate() { }


    /**
     * Not implemented
     */
    public void ejbPassivate() { }


    /**
     * Not implemented
     */
    public void ejbLoad() { }


    /**
     * Not implemented
     */
    public void ejbStore() { }


    /**
     * Not implemented
     */
    public void ejbRemove() { }
}
