// $Id: ReplicaStateRemote.java,v 1.4 2004/03/05 23:05:10 gca Exp $

package com.spamnbeans.server;

/**
 * Provide the external interface to the ReplicaState SessionBean.
 * 
 * <p>The ReplicaState Bean is monitored by the GlobalReplicationManager 
 * to make sure the replica is still alive, and to determine the load from client
 * requests.
 * 
 * @author Gary Ackley, 
 *         <a href="mailto:gca@andrew.cmu.edu">gca@andrew.cmu.edu</a>
 * @version $Revision: 1.4 $
 */
public interface ReplicaStateRemote extends javax.ejb.EJBObject {

	/**
	 * Called by ReplicaMonitor to fetch the number of client requests 
	 * processed since last call.
	 */
	public long getNbrRequests() throws java.rmi.RemoteException;

}
