// $RCSfile: TestCase3.java,v $
// $Author: aboyer $ 
// $Date: 2004/02/25 14:54:38 $
// $Revision: 1.4 $

package com.spamnbeans.test;

import com.spamnbeans.client.*;
import java.io.*;

public class TestCase3
{
    public static void main(String [] args) throws Throwable
    {
	System.out.println( "*** Running SpamNBeans Test Case 3..." );

	MPManager mgr = new MPManager();
	MPClient mpc = new MPClient();

	System.out.println( "\n*** Setup environment - ignore errors:" );
	String [] clargsA = {"server", "create", "0", "localhost"};
	mgr.main( clargsA );

	System.out.println( "\n*** Flush clients:" );
	String [] clargs1 = {"client", "flush"};
	mgr.main( clargs1 );

	System.out.println( "\n*** Flush messages:" );
	String [] clargs2 = {"msg", "flush"};
	mgr.main( clargs2 );

	System.out.println( "\n*** Create client 101 - should succeed:" );
	String [] clargs3 = {"client", "create", "101", "client101"};
	mgr.main( clargs3 );

	File spamf;
	FileInputStream spamstr;

	// Load spam into StdIn
	try {
	    spamf = new File( "scripts/test2.spam" );
	    spamstr = new FileInputStream( spamf );
	    System.setIn( spamstr );
	} catch (Throwable t) {
	    System.out.println( "Error: Couldn't find test data, aborting" );
	    return;
	}

	// Process message with client 100
	System.out.println( "\n*** Use client 100 - no headers generated:" );
	String [] clargs4 = {"100"};
	mpc.main( clargs4 );

	// Reload spam into StdIn
	try {
	    spamstr.close();
	    spamstr = new FileInputStream( spamf );
	    System.setIn( spamstr );
	} catch (Throwable t) {
	    System.out.println( "Error: Couldn't find test data, aborting" );
	    return;
	}

	// Process message with client 101
	System.out.println( "\n*** Use client 101 - headers added:" );
	String [] clargs5 = {"101"};
	mpc.main( clargs5 );

	try {
	    spamstr.close();
	} catch (Throwable t) { } // Ignore
    }
}
