/**
 * $Id: TestMsgBean.java,v 1.7 2004/02/25 06:02:54 aboyer Exp $
 * A Session bean for testing the Msg entity bean
 * - allows remote clients to test Msg
 */
package com.spamnbeans.test;
import com.spamnbeans.msg.*;

import javax.ejb.*;
import javax.naming.*;
import java.rmi.*;
import java.util.Iterator;
import java.io.PrintWriter;
import java.io.StringWriter;

public class TestMsgBean implements javax.ejb.SessionBean 
{
	String strClass = "TestMsgBean";

	public SessionContext context;

	public void ejbCreate() {
	}
	public void ejbActivate() {
	}
	public void ejbPassivate() {
	}
	public void ejbRemove() {
	}
	public void setSessionContext(SessionContext ctx) {
		context = ctx;
	}

	public InitialContext getInitialContext()
		throws javax.naming.NamingException {
		return new InitialContext();
	}
	
	public void findAllMsgs( MsgHomeLocal msghome, PrintWriter out ) 
	throws RemoteException, FinderException {
		String strFnc = strClass + ".findAllMsgs : ";
		String strMsg = "\tmsgPK\tmsgID\tclientID\tserverID\ttimeStamp\tmsgSize\tmsgState";
		
		System.out.println( strMsg );
		out.println(strMsg);
		
		Iterator iter = msghome.findAllMsgs().iterator();
		while(iter.hasNext()) {
			MsgLocal msg = (MsgLocal)iter.next();
			strMsg = ( "\t" 
					+ msg.getPrimaryKey().toString()+ "\t"
					+ msg.getMsgID().toString()+ "\t"
					+ msg.getClientID().toString()+ "\t"
					+ msg.getServerID().toString()+ "\t"
					+ msg.getTimeStamp()+ "\t"
					+ msg.getMsgSize().toString()+ "\t"
					+ msg.getMsgState().toString());
			System.out.println(strFnc + strMsg);
			out.println(strMsg);
		}
	}

	public void findByClientID( Integer clientID, 
			MsgHomeLocal msghome, PrintWriter out ) 
	throws RemoteException, FinderException {
		String strFnc = strClass + ".findByClientID : ";
		String strMsg = "\tmsgPK\tmsgID\tclientID\tserverID\ttimeStamp\tmsgSize\tmsgState";
		
		System.out.println( strMsg );
		out.println(strMsg);
		
		Iterator iter = msghome.findByClientID(clientID).iterator();
		while(iter.hasNext()) {
			MsgLocal msg = (MsgLocal)iter.next();
			strMsg = ( "\t" 
					+ msg.getPrimaryKey().toString()+ "\t"
					+ msg.getMsgID().toString()+ "\t"
					+ msg.getClientID().toString()+ "\t"
					+ msg.getServerID().toString()+ "\t"
					+ msg.getTimeStamp()+ "\t"
					+ msg.getMsgSize().toString()+ "\t"
					+ msg.getMsgState().toString());
			System.out.println(strFnc + strMsg);
			out.println(strMsg);
		}
	}

	public void findByServerID( Integer serverID, 
			MsgHomeLocal msghome, PrintWriter out ) 
	throws RemoteException, FinderException {
		String strFnc = strClass + ".findByServerID : ";
		String strMsg = "\tmsgPK\tmsgID\tclientID\tserverID\ttimeStamp\tmsgSize\tmsgState";
		
		System.out.println( strMsg );
		out.println(strMsg);
		
		Iterator iter = msghome.findByServerID(serverID).iterator();
		while(iter.hasNext()) {
			MsgLocal msg = (MsgLocal)iter.next();
			strMsg = ( "\t" 
					+ msg.getPrimaryKey().toString()+ "\t"
					+ msg.getMsgID().toString()+ "\t"
					+ msg.getClientID().toString()+ "\t"
					+ msg.getServerID().toString()+ "\t"
					+ msg.getTimeStamp()+ "\t"
					+ msg.getMsgSize().toString()+ "\t"
					+ msg.getMsgState().toString());
			System.out.println(strFnc + strMsg);
			out.println(strMsg);
		}
	}

	public String runMsgTest() throws RemoteException, TestFailureException {
		String strFnc = strClass + ".runMsgTest : ";
		String output = null;
		StringWriter writer = new StringWriter();
		PrintWriter out = new PrintWriter(writer);
		boolean fHitError = false;
		String strMsg = null;
		
		// Test #1 - create some a Msg object
		// - then use get/set methods to manipulate it
		try {
			// obtain a reference to the Msg Local Home Object (MsgHomeLocal)
			// - This is the factory for Msg EJB Local Objects
			InitialContext jndiContext = getInitialContext();
			Object obj = jndiContext.lookup("MsgHomeLocal");
			MsgHomeLocal msghome = (MsgHomeLocal) obj;

			// Use the factory to create the Msg EJB Object
			strMsg = strFnc + "Creating Msg bean...";
			System.out.println(strMsg);
			out.println(strMsg);
			Object msgPK;
			Integer msgID;
			Integer clientID = new Integer(0);
			Integer serverID = new Integer(0);
			String timeStamp = "Not Implemented";
			Integer msgSize = new Integer(255);
			Integer msgState = new Integer(0);

			MsgLocal msg =
				msghome.createMsg(
						  new Integer(12),
					clientID,
					serverID,
					timeStamp,
					msgSize,
					msgState);

			// Use get methods to verify object is set as expected
			strMsg = strFnc + "Validating Msg bean...";
			System.out.println( strMsg );
			out.println( strMsg );
			msgPK = msg.getPrimaryKey();
			msgID = msg.getMsgID();
			System.out.println( strFnc + "MsgPK/MsgID:"
					+ msgPK.toString()
					+ msgID.toString());
			if (!msg.getClientID().equals(clientID)
				|| !msg.getServerID().equals(serverID)
				|| !msg.getTimeStamp().equals(timeStamp)
				|| !msg.getMsgSize().equals(msgSize)
				|| !msg.getMsgState().equals(msgState)) {
				strMsg = "ERROR! Test Failed Validation!";
				System.out.println("TestMsgBean.runMsgTest : " + strMsg);
				out.println("TestMsgBean.runMsgTest : " + strMsg);
				throw new TestFailureException(strMsg);
			}

			// Generate new values for set methods
			strMsg = strFnc + "Updating Msg bean...";
			System.out.println( strMsg );
			out.println( strMsg );
			Object msgPK2;
			Integer msgID2;
			Integer clientID2 = new Integer(clientID.intValue() + 2);
			Integer serverID2 = new Integer(serverID.intValue() + 2);
			String timeStamp2 = new String("New Value");
			Integer msgSize2 = new Integer(msgSize.intValue() + 100);
			Integer msgState2 = new Integer(msgState.intValue() + 1);

			// Manipulate the object via get/set methods
			msg.setClientID(clientID2);
			msg.setServerID(serverID2);
			msg.setTimeStamp(timeStamp2);
			msg.setMsgSize(msgSize2);
			msg.setMsgState(msgState2);

			// Use get methods to verify object is set as expected
			strMsg = strFnc + "2nd Validating Msg bean...";
			System.out.println( strMsg );
			out.println( strMsg );
			msgPK2 = msg.getPrimaryKey();
			msgID2 = msg.getMsgID();
			if (!msgPK.equals(msgPK2)
				|| !msgID2.equals(msgID)
				|| !msg.getClientID().equals(clientID2)
				|| !msg.getServerID().equals(serverID2)
				|| !msg.getTimeStamp().equals(timeStamp2)
				|| !msg.getMsgSize().equals(msgSize2)
				|| !msg.getMsgState().equals(msgState2)) {
				strMsg = "ERROR! Test Failed 2nd Validation!";
				out.println( strFnc + strMsg);
				throw new TestFailureException(strMsg);
			}

			// Try findByPrimaryKey
			strMsg = strFnc + "Finding Msg bean...";
			System.out.println( strMsg );
			out.println( strMsg );
			MsgLocal msg2 = msghome.findByPrimaryKey(msgID);
			msgPK2 = msg2.getPrimaryKey();
			msgID2 = msg2.getMsgID();
			System.out.println( strFnc + "MsgPK/MsgID:"
					+ msgPK.toString()
					+ msgID.toString());
			if (!msgPK2.equals(msgPK)
				|| !msgID2.equals(msgID)
				|| !msg2.getClientID().equals(clientID2)
				|| !msg2.getServerID().equals(serverID2)
				|| !msg2.getTimeStamp().equals(timeStamp2)
				|| !msg2.getMsgSize().equals(msgSize2)
				|| !msg2.getMsgState().equals(msgState2)) {
				strMsg = "ERROR! Test Failed Find Validation!\n"
						+ "\t\tExpected \tRetrieved\n"
						+ "msgPK\t"+ msgPK2.toString()+ "\t"+ msg2.getPrimaryKey().toString()+ "\n"
						+ "msgID\t"+ msgID2.toString()+ "\t"+ msg2.getMsgID().toString()+ "\n"
						+ "clientID\t"+ clientID2.toString()+ "\t"+ msg2.getClientID().toString()+ "\n"
						+ "serverID\t"+ serverID2.toString()+ "\t"+ msg2.getServerID().toString()+ "\n"
						+ "timeStamp\t"+ timeStamp2+ "\t"+ msg2.getTimeStamp()+ "\n"
						+ "msgSize\t"+ msgSize2.toString()+ "\t"+ msg2.getMsgSize().toString()+ "\n"
						+ "msgState\t"+ msgState2.toString()+ "\t"+ msg2.getMsgState().toString();
				out.println( strFnc + strMsg);
				throw new TestFailureException(strMsg);
			}
			
			// Delete the object to destroy the database record
			strMsg = strFnc + "Removing Msg bean...";
			System.out.println( strMsg );
			out.println( strMsg );
			msg.remove();
			
			// Try findAllMsgs
			strMsg = strFnc + "Listing ALL Msg beans...";
			System.out.println( strMsg );
			out.println( strMsg );
			try {
				findAllMsgs( msghome, out );
			}
			catch( FinderException e ) {
				strMsg = strFnc + "-- No Msg Beans to List --";
				System.out.println( strMsg );
				out.println( strMsg );
			}
			
			// Try findByClientID
			strMsg = strFnc + "Listing Msg beans for clientID[" + clientID2 +"] ...";
			System.out.println( strMsg );
			out.println( strMsg );
			try {
				findByClientID( clientID, msghome, out );
			}
			catch( FinderException e ) {
				strMsg = strFnc + "-- No Msg Beans to List --";
				System.out.println( strMsg );
				out.println( strMsg );
			}
			
			// Try findByServerID
			strMsg = strFnc + "Listing Msg beans for serverID[" + serverID2 +"] ...";
			System.out.println( strMsg );
			out.println( strMsg );
			try {
				findByServerID( clientID, msghome, out );
			}
			catch( FinderException e ) {
				strMsg = strFnc + "-- No Msg Beans to List --";
				System.out.println( strMsg );
				out.println( strMsg );
			}
			
			// TODO: Try other finder methods
			/*
			 * Done - public MsgLocal findByPrimaryKey(Integer msgID)
			 * Done - public Collection findByClientID(Integer clientID)
			 * Done - public Collection findByServerID(Integer serverID)
			 * public Collection findByTimeStamp(String timeStamp)
			 * public Collection findByMsgSize(Integer msgSize)
			 * Done - public Collection findAllMsgs()
			 */
			
		} catch (Exception ex) {
			fHitError = true;
			//      	ex.printStackTrace(out);
		}

		// Report test results
		if (fHitError) {
			out.println("Test FAILED!");
		} else {
			out.println("Test PASSED!");
		}
		out.close();
		output = writer.toString();
		return output;
	}

}
